<a id="mypy-boto3-rds"></a>

# mypy-boto3-rds

[![PyPI - mypy-boto3-rds](https://img.shields.io/pypi/v/mypy-boto3-rds.svg?color=blue)](https://pypi.org/project/mypy-boto3-rds)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-rds.svg?color=blue)](https://pypi.org/project/mypy-boto3-rds)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-rds?color=blue)](https://pypistats.org/packages/mypy-boto3-rds)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.RDS 1.17.102](https://boto3.amazonaws.com/v1/documentation/api/1.17.102/reference/services/rds.html#RDS)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-buider 4.20.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-rds docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_rds/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-rds](#mypy-boto3-rds)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

Install `boto3-stubs` for `RDS` service.

```bash
python -m pip install boto3-stubs[rds]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[rds]` in your environment:
  `python -m pip install 'boto3-stubs[rds]'`

Both type checking and auto-complete should work for `RDS` service. No explicit
type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[rds]` in your environment:
  `python -m pip install 'boto3-stubs[rds]'`

Both type checking and auto-complete should work for `RDS` service. No explicit
type annotations required, write your `boto3` code as usual. Auto-complete can
be slow on big projects or if you have a lot of installed `boto3-stubs`
submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[rds]` in your environment:
  `python -m pip install 'boto3-stubs[rds]'`
- Run `mypy` as usual

Type checking should work for `RDS` service. No explicit type annotations
required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[rds]` in your environment:
  `python -m pip install 'boto3-stubs[rds]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `RDS` service. No explicit type annotations
required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`RDSClient` provides annotations for `boto3.client("rds")`.

```python
import boto3

from mypy_boto3_rds import RDSClient

client: RDSClient = boto3.client("rds")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: RDSClient = session.client("rds")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_rds.paginator` module contains type annotations for all paginators.

```python
from mypy_boto3_rds import RDSClient
from mypy_boto3_rds.paginator import (
    DescribeCertificatesPaginator,
    DescribeCustomAvailabilityZonesPaginator,
    DescribeDBClusterBacktracksPaginator,
    DescribeDBClusterEndpointsPaginator,
    DescribeDBClusterParameterGroupsPaginator,
    DescribeDBClusterParametersPaginator,
    DescribeDBClusterSnapshotsPaginator,
    DescribeDBClustersPaginator,
    DescribeDBEngineVersionsPaginator,
    DescribeDBInstanceAutomatedBackupsPaginator,
    DescribeDBInstancesPaginator,
    DescribeDBLogFilesPaginator,
    DescribeDBParameterGroupsPaginator,
    DescribeDBParametersPaginator,
    DescribeDBProxiesPaginator,
    DescribeDBProxyEndpointsPaginator,
    DescribeDBProxyTargetGroupsPaginator,
    DescribeDBProxyTargetsPaginator,
    DescribeDBSecurityGroupsPaginator,
    DescribeDBSnapshotsPaginator,
    DescribeDBSubnetGroupsPaginator,
    DescribeEngineDefaultClusterParametersPaginator,
    DescribeEngineDefaultParametersPaginator,
    DescribeEventSubscriptionsPaginator,
    DescribeEventsPaginator,
    DescribeExportTasksPaginator,
    DescribeGlobalClustersPaginator,
    DescribeInstallationMediaPaginator,
    DescribeOptionGroupOptionsPaginator,
    DescribeOptionGroupsPaginator,
    DescribeOrderableDBInstanceOptionsPaginator,
    DescribePendingMaintenanceActionsPaginator,
    DescribeReservedDBInstancesPaginator,
    DescribeReservedDBInstancesOfferingsPaginator,
    DescribeSourceRegionsPaginator,
    DownloadDBLogFilePortionPaginator,
)

client: RDSClient = boto3.client("rds")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
describe_certificates_paginator: DescribeCertificatesPaginator = client.get_paginator("describe_certificates")
describe_custom_availability_zones_paginator: DescribeCustomAvailabilityZonesPaginator = client.get_paginator("describe_custom_availability_zones")
describe_db_cluster_backtracks_paginator: DescribeDBClusterBacktracksPaginator = client.get_paginator("describe_db_cluster_backtracks")
describe_db_cluster_endpoints_paginator: DescribeDBClusterEndpointsPaginator = client.get_paginator("describe_db_cluster_endpoints")
describe_db_cluster_parameter_groups_paginator: DescribeDBClusterParameterGroupsPaginator = client.get_paginator("describe_db_cluster_parameter_groups")
describe_db_cluster_parameters_paginator: DescribeDBClusterParametersPaginator = client.get_paginator("describe_db_cluster_parameters")
describe_db_cluster_snapshots_paginator: DescribeDBClusterSnapshotsPaginator = client.get_paginator("describe_db_cluster_snapshots")
describe_db_clusters_paginator: DescribeDBClustersPaginator = client.get_paginator("describe_db_clusters")
describe_db_engine_versions_paginator: DescribeDBEngineVersionsPaginator = client.get_paginator("describe_db_engine_versions")
describe_db_instance_automated_backups_paginator: DescribeDBInstanceAutomatedBackupsPaginator = client.get_paginator("describe_db_instance_automated_backups")
describe_db_instances_paginator: DescribeDBInstancesPaginator = client.get_paginator("describe_db_instances")
describe_db_log_files_paginator: DescribeDBLogFilesPaginator = client.get_paginator("describe_db_log_files")
describe_db_parameter_groups_paginator: DescribeDBParameterGroupsPaginator = client.get_paginator("describe_db_parameter_groups")
describe_db_parameters_paginator: DescribeDBParametersPaginator = client.get_paginator("describe_db_parameters")
describe_db_proxies_paginator: DescribeDBProxiesPaginator = client.get_paginator("describe_db_proxies")
describe_db_proxy_endpoints_paginator: DescribeDBProxyEndpointsPaginator = client.get_paginator("describe_db_proxy_endpoints")
describe_db_proxy_target_groups_paginator: DescribeDBProxyTargetGroupsPaginator = client.get_paginator("describe_db_proxy_target_groups")
describe_db_proxy_targets_paginator: DescribeDBProxyTargetsPaginator = client.get_paginator("describe_db_proxy_targets")
describe_db_security_groups_paginator: DescribeDBSecurityGroupsPaginator = client.get_paginator("describe_db_security_groups")
describe_db_snapshots_paginator: DescribeDBSnapshotsPaginator = client.get_paginator("describe_db_snapshots")
describe_db_subnet_groups_paginator: DescribeDBSubnetGroupsPaginator = client.get_paginator("describe_db_subnet_groups")
describe_engine_default_cluster_parameters_paginator: DescribeEngineDefaultClusterParametersPaginator = client.get_paginator("describe_engine_default_cluster_parameters")
describe_engine_default_parameters_paginator: DescribeEngineDefaultParametersPaginator = client.get_paginator("describe_engine_default_parameters")
describe_event_subscriptions_paginator: DescribeEventSubscriptionsPaginator = client.get_paginator("describe_event_subscriptions")
describe_events_paginator: DescribeEventsPaginator = client.get_paginator("describe_events")
describe_export_tasks_paginator: DescribeExportTasksPaginator = client.get_paginator("describe_export_tasks")
describe_global_clusters_paginator: DescribeGlobalClustersPaginator = client.get_paginator("describe_global_clusters")
describe_installation_media_paginator: DescribeInstallationMediaPaginator = client.get_paginator("describe_installation_media")
describe_option_group_options_paginator: DescribeOptionGroupOptionsPaginator = client.get_paginator("describe_option_group_options")
describe_option_groups_paginator: DescribeOptionGroupsPaginator = client.get_paginator("describe_option_groups")
describe_orderable_db_instance_options_paginator: DescribeOrderableDBInstanceOptionsPaginator = client.get_paginator("describe_orderable_db_instance_options")
describe_pending_maintenance_actions_paginator: DescribePendingMaintenanceActionsPaginator = client.get_paginator("describe_pending_maintenance_actions")
describe_reserved_db_instances_paginator: DescribeReservedDBInstancesPaginator = client.get_paginator("describe_reserved_db_instances")
describe_reserved_db_instances_offerings_paginator: DescribeReservedDBInstancesOfferingsPaginator = client.get_paginator("describe_reserved_db_instances_offerings")
describe_source_regions_paginator: DescribeSourceRegionsPaginator = client.get_paginator("describe_source_regions")
download_db_log_file_portion_paginator: DownloadDBLogFilePortionPaginator = client.get_paginator("download_db_log_file_portion")
```

<a id="waiters-annotations"></a>

### Waiters annotations

`mypy_boto3_rds.waiter` module contains type annotations for all waiters.

```python
from mypy_boto3_rds import RDSClient
from mypy_boto3_rds.waiter import (
    DBClusterSnapshotAvailableWaiter,
    DBClusterSnapshotDeletedWaiter,
    DBInstanceAvailableWaiter,
    DBInstanceDeletedWaiter,
    DBSnapshotAvailableWaiter,
    DBSnapshotCompletedWaiter,
    DBSnapshotDeletedWaiter,
)

client: RDSClient = boto3.client("rds")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
db_cluster_snapshot_available_waiter: DBClusterSnapshotAvailableWaiter = client.get_waiter("db_cluster_snapshot_available")
db_cluster_snapshot_deleted_waiter: DBClusterSnapshotDeletedWaiter = client.get_waiter("db_cluster_snapshot_deleted")
db_instance_available_waiter: DBInstanceAvailableWaiter = client.get_waiter("db_instance_available")
db_instance_deleted_waiter: DBInstanceDeletedWaiter = client.get_waiter("db_instance_deleted")
db_snapshot_available_waiter: DBSnapshotAvailableWaiter = client.get_waiter("db_snapshot_available")
db_snapshot_completed_waiter: DBSnapshotCompletedWaiter = client.get_waiter("db_snapshot_completed")
db_snapshot_deleted_waiter: DBSnapshotDeletedWaiter = client.get_waiter("db_snapshot_deleted")
```

<a id="literals"></a>

### Literals

`mypy_boto3_rds.literals` module contains literals extracted from shapes that
can be used in user code for type checking.

```python
from mypy_boto3_rds.literals import (
    ActivityStreamModeType,
    ActivityStreamStatusType,
    ApplyMethodType,
    AuthSchemeType,
    DBClusterSnapshotAvailableWaiterName,
    DBClusterSnapshotDeletedWaiterName,
    DBInstanceAvailableWaiterName,
    DBInstanceDeletedWaiterName,
    DBProxyEndpointStatusType,
    DBProxyEndpointTargetRoleType,
    DBProxyStatusType,
    DBSnapshotAvailableWaiterName,
    DBSnapshotCompletedWaiterName,
    DBSnapshotDeletedWaiterName,
    DescribeCertificatesPaginatorName,
    DescribeCustomAvailabilityZonesPaginatorName,
    DescribeDBClusterBacktracksPaginatorName,
    DescribeDBClusterEndpointsPaginatorName,
    DescribeDBClusterParameterGroupsPaginatorName,
    DescribeDBClusterParametersPaginatorName,
    DescribeDBClusterSnapshotsPaginatorName,
    DescribeDBClustersPaginatorName,
    DescribeDBEngineVersionsPaginatorName,
    DescribeDBInstanceAutomatedBackupsPaginatorName,
    DescribeDBInstancesPaginatorName,
    DescribeDBLogFilesPaginatorName,
    DescribeDBParameterGroupsPaginatorName,
    DescribeDBParametersPaginatorName,
    DescribeDBProxiesPaginatorName,
    DescribeDBProxyEndpointsPaginatorName,
    DescribeDBProxyTargetGroupsPaginatorName,
    DescribeDBProxyTargetsPaginatorName,
    DescribeDBSecurityGroupsPaginatorName,
    DescribeDBSnapshotsPaginatorName,
    DescribeDBSubnetGroupsPaginatorName,
    DescribeEngineDefaultClusterParametersPaginatorName,
    DescribeEngineDefaultParametersPaginatorName,
    DescribeEventSubscriptionsPaginatorName,
    DescribeEventsPaginatorName,
    DescribeExportTasksPaginatorName,
    DescribeGlobalClustersPaginatorName,
    DescribeInstallationMediaPaginatorName,
    DescribeOptionGroupOptionsPaginatorName,
    DescribeOptionGroupsPaginatorName,
    DescribeOrderableDBInstanceOptionsPaginatorName,
    DescribePendingMaintenanceActionsPaginatorName,
    DescribeReservedDBInstancesOfferingsPaginatorName,
    DescribeReservedDBInstancesPaginatorName,
    DescribeSourceRegionsPaginatorName,
    DownloadDBLogFilePortionPaginatorName,
    EngineFamilyType,
    FailoverStatusType,
    IAMAuthModeType,
    ReplicaModeType,
    SourceTypeType,
    TargetHealthReasonType,
    TargetRoleType,
    TargetStateType,
    TargetTypeType,
    WriteForwardingStatusType,
)

def check_value(value: ActivityStreamModeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_rds.type_defs` module contains structures and shapes assembled to
typed dictionaries for additional type checking.

```python
from mypy_boto3_rds.type_defs import (
    AccountAttributesMessageResponseTypeDef,
    AccountQuotaTypeDef,
    AddRoleToDBClusterMessageTypeDef,
    AddRoleToDBInstanceMessageTypeDef,
    AddSourceIdentifierToSubscriptionMessageTypeDef,
    AddSourceIdentifierToSubscriptionResultResponseTypeDef,
    AddTagsToResourceMessageTypeDef,
    ApplyPendingMaintenanceActionMessageTypeDef,
    ApplyPendingMaintenanceActionResultResponseTypeDef,
    AuthorizeDBSecurityGroupIngressMessageTypeDef,
    AuthorizeDBSecurityGroupIngressResultResponseTypeDef,
    AvailabilityZoneTypeDef,
    AvailableProcessorFeatureTypeDef,
    BacktrackDBClusterMessageTypeDef,
    CancelExportTaskMessageTypeDef,
    CertificateMessageResponseTypeDef,
    CertificateTypeDef,
    CharacterSetTypeDef,
    ClientGenerateDbAuthTokenRequestTypeDef,
    CloudwatchLogsExportConfigurationTypeDef,
    ClusterPendingModifiedValuesTypeDef,
    ConnectionPoolConfigurationInfoTypeDef,
    ConnectionPoolConfigurationTypeDef,
    CopyDBClusterParameterGroupMessageTypeDef,
    CopyDBClusterParameterGroupResultResponseTypeDef,
    CopyDBClusterSnapshotMessageTypeDef,
    CopyDBClusterSnapshotResultResponseTypeDef,
    CopyDBParameterGroupMessageTypeDef,
    CopyDBParameterGroupResultResponseTypeDef,
    CopyDBSnapshotMessageTypeDef,
    CopyDBSnapshotResultResponseTypeDef,
    CopyOptionGroupMessageTypeDef,
    CopyOptionGroupResultResponseTypeDef,
    CreateCustomAvailabilityZoneMessageTypeDef,
    CreateCustomAvailabilityZoneResultResponseTypeDef,
    CreateDBClusterEndpointMessageTypeDef,
    CreateDBClusterMessageTypeDef,
    CreateDBClusterParameterGroupMessageTypeDef,
    CreateDBClusterParameterGroupResultResponseTypeDef,
    CreateDBClusterResultResponseTypeDef,
    CreateDBClusterSnapshotMessageTypeDef,
    CreateDBClusterSnapshotResultResponseTypeDef,
    CreateDBInstanceMessageTypeDef,
    CreateDBInstanceReadReplicaMessageTypeDef,
    CreateDBInstanceReadReplicaResultResponseTypeDef,
    CreateDBInstanceResultResponseTypeDef,
    CreateDBParameterGroupMessageTypeDef,
    CreateDBParameterGroupResultResponseTypeDef,
    CreateDBProxyEndpointRequestTypeDef,
    CreateDBProxyEndpointResponseResponseTypeDef,
    CreateDBProxyRequestTypeDef,
    CreateDBProxyResponseResponseTypeDef,
    CreateDBSecurityGroupMessageTypeDef,
    CreateDBSecurityGroupResultResponseTypeDef,
    CreateDBSnapshotMessageTypeDef,
    CreateDBSnapshotResultResponseTypeDef,
    CreateDBSubnetGroupMessageTypeDef,
    CreateDBSubnetGroupResultResponseTypeDef,
    CreateEventSubscriptionMessageTypeDef,
    CreateEventSubscriptionResultResponseTypeDef,
    CreateGlobalClusterMessageTypeDef,
    CreateGlobalClusterResultResponseTypeDef,
    CreateOptionGroupMessageTypeDef,
    CreateOptionGroupResultResponseTypeDef,
    CustomAvailabilityZoneMessageResponseTypeDef,
    CustomAvailabilityZoneTypeDef,
    DBClusterBacktrackMessageResponseTypeDef,
    DBClusterBacktrackResponseTypeDef,
    DBClusterCapacityInfoResponseTypeDef,
    DBClusterEndpointMessageResponseTypeDef,
    DBClusterEndpointResponseTypeDef,
    DBClusterMemberTypeDef,
    DBClusterMessageResponseTypeDef,
    DBClusterOptionGroupStatusTypeDef,
    DBClusterParameterGroupDetailsResponseTypeDef,
    DBClusterParameterGroupNameMessageResponseTypeDef,
    DBClusterParameterGroupTypeDef,
    DBClusterParameterGroupsMessageResponseTypeDef,
    DBClusterRoleTypeDef,
    DBClusterSnapshotAttributeTypeDef,
    DBClusterSnapshotAttributesResultTypeDef,
    DBClusterSnapshotMessageResponseTypeDef,
    DBClusterSnapshotTypeDef,
    DBClusterTypeDef,
    DBEngineVersionMessageResponseTypeDef,
    DBEngineVersionTypeDef,
    DBInstanceAutomatedBackupMessageResponseTypeDef,
    DBInstanceAutomatedBackupTypeDef,
    DBInstanceAutomatedBackupsReplicationTypeDef,
    DBInstanceMessageResponseTypeDef,
    DBInstanceRoleTypeDef,
    DBInstanceStatusInfoTypeDef,
    DBInstanceTypeDef,
    DBParameterGroupDetailsResponseTypeDef,
    DBParameterGroupNameMessageResponseTypeDef,
    DBParameterGroupStatusTypeDef,
    DBParameterGroupTypeDef,
    DBParameterGroupsMessageResponseTypeDef,
    DBProxyEndpointTypeDef,
    DBProxyTargetGroupTypeDef,
    DBProxyTargetTypeDef,
    DBProxyTypeDef,
    DBSecurityGroupMembershipTypeDef,
    DBSecurityGroupMessageResponseTypeDef,
    DBSecurityGroupTypeDef,
    DBSnapshotAttributeTypeDef,
    DBSnapshotAttributesResultTypeDef,
    DBSnapshotMessageResponseTypeDef,
    DBSnapshotTypeDef,
    DBSubnetGroupMessageResponseTypeDef,
    DBSubnetGroupTypeDef,
    DeleteCustomAvailabilityZoneMessageTypeDef,
    DeleteCustomAvailabilityZoneResultResponseTypeDef,
    DeleteDBClusterEndpointMessageTypeDef,
    DeleteDBClusterMessageTypeDef,
    DeleteDBClusterParameterGroupMessageTypeDef,
    DeleteDBClusterResultResponseTypeDef,
    DeleteDBClusterSnapshotMessageTypeDef,
    DeleteDBClusterSnapshotResultResponseTypeDef,
    DeleteDBInstanceAutomatedBackupMessageTypeDef,
    DeleteDBInstanceAutomatedBackupResultResponseTypeDef,
    DeleteDBInstanceMessageTypeDef,
    DeleteDBInstanceResultResponseTypeDef,
    DeleteDBParameterGroupMessageTypeDef,
    DeleteDBProxyEndpointRequestTypeDef,
    DeleteDBProxyEndpointResponseResponseTypeDef,
    DeleteDBProxyRequestTypeDef,
    DeleteDBProxyResponseResponseTypeDef,
    DeleteDBSecurityGroupMessageTypeDef,
    DeleteDBSnapshotMessageTypeDef,
    DeleteDBSnapshotResultResponseTypeDef,
    DeleteDBSubnetGroupMessageTypeDef,
    DeleteEventSubscriptionMessageTypeDef,
    DeleteEventSubscriptionResultResponseTypeDef,
    DeleteGlobalClusterMessageTypeDef,
    DeleteGlobalClusterResultResponseTypeDef,
    DeleteInstallationMediaMessageTypeDef,
    DeleteOptionGroupMessageTypeDef,
    DeregisterDBProxyTargetsRequestTypeDef,
    DescribeCertificatesMessageTypeDef,
    DescribeCustomAvailabilityZonesMessageTypeDef,
    DescribeDBClusterBacktracksMessageTypeDef,
    DescribeDBClusterEndpointsMessageTypeDef,
    DescribeDBClusterParameterGroupsMessageTypeDef,
    DescribeDBClusterParametersMessageTypeDef,
    DescribeDBClusterSnapshotAttributesMessageTypeDef,
    DescribeDBClusterSnapshotAttributesResultResponseTypeDef,
    DescribeDBClusterSnapshotsMessageTypeDef,
    DescribeDBClustersMessageTypeDef,
    DescribeDBEngineVersionsMessageTypeDef,
    DescribeDBInstanceAutomatedBackupsMessageTypeDef,
    DescribeDBInstancesMessageTypeDef,
    DescribeDBLogFilesDetailsTypeDef,
    DescribeDBLogFilesMessageTypeDef,
    DescribeDBLogFilesResponseResponseTypeDef,
    DescribeDBParameterGroupsMessageTypeDef,
    DescribeDBParametersMessageTypeDef,
    DescribeDBProxiesRequestTypeDef,
    DescribeDBProxiesResponseResponseTypeDef,
    DescribeDBProxyEndpointsRequestTypeDef,
    DescribeDBProxyEndpointsResponseResponseTypeDef,
    DescribeDBProxyTargetGroupsRequestTypeDef,
    DescribeDBProxyTargetGroupsResponseResponseTypeDef,
    DescribeDBProxyTargetsRequestTypeDef,
    DescribeDBProxyTargetsResponseResponseTypeDef,
    DescribeDBSecurityGroupsMessageTypeDef,
    DescribeDBSnapshotAttributesMessageTypeDef,
    DescribeDBSnapshotAttributesResultResponseTypeDef,
    DescribeDBSnapshotsMessageTypeDef,
    DescribeDBSubnetGroupsMessageTypeDef,
    DescribeEngineDefaultClusterParametersMessageTypeDef,
    DescribeEngineDefaultClusterParametersResultResponseTypeDef,
    DescribeEngineDefaultParametersMessageTypeDef,
    DescribeEngineDefaultParametersResultResponseTypeDef,
    DescribeEventCategoriesMessageTypeDef,
    DescribeEventSubscriptionsMessageTypeDef,
    DescribeEventsMessageTypeDef,
    DescribeExportTasksMessageTypeDef,
    DescribeGlobalClustersMessageTypeDef,
    DescribeInstallationMediaMessageTypeDef,
    DescribeOptionGroupOptionsMessageTypeDef,
    DescribeOptionGroupsMessageTypeDef,
    DescribeOrderableDBInstanceOptionsMessageTypeDef,
    DescribePendingMaintenanceActionsMessageTypeDef,
    DescribeReservedDBInstancesMessageTypeDef,
    DescribeReservedDBInstancesOfferingsMessageTypeDef,
    DescribeSourceRegionsMessageTypeDef,
    DescribeValidDBInstanceModificationsMessageTypeDef,
    DescribeValidDBInstanceModificationsResultResponseTypeDef,
    DomainMembershipTypeDef,
    DoubleRangeTypeDef,
    DownloadDBLogFilePortionDetailsResponseTypeDef,
    DownloadDBLogFilePortionMessageTypeDef,
    EC2SecurityGroupTypeDef,
    EndpointTypeDef,
    EngineDefaultsTypeDef,
    EventCategoriesMapTypeDef,
    EventCategoriesMessageResponseTypeDef,
    EventSubscriptionTypeDef,
    EventSubscriptionsMessageResponseTypeDef,
    EventTypeDef,
    EventsMessageResponseTypeDef,
    ExportTaskResponseTypeDef,
    ExportTasksMessageResponseTypeDef,
    FailoverDBClusterMessageTypeDef,
    FailoverDBClusterResultResponseTypeDef,
    FailoverGlobalClusterMessageTypeDef,
    FailoverGlobalClusterResultResponseTypeDef,
    FailoverStateTypeDef,
    FilterTypeDef,
    GlobalClusterMemberTypeDef,
    GlobalClusterTypeDef,
    GlobalClustersMessageResponseTypeDef,
    IPRangeTypeDef,
    ImportInstallationMediaMessageTypeDef,
    InstallationMediaFailureCauseTypeDef,
    InstallationMediaMessageResponseTypeDef,
    InstallationMediaResponseTypeDef,
    ListTagsForResourceMessageTypeDef,
    MinimumEngineVersionPerAllowedValueTypeDef,
    ModifyCertificatesMessageTypeDef,
    ModifyCertificatesResultResponseTypeDef,
    ModifyCurrentDBClusterCapacityMessageTypeDef,
    ModifyDBClusterEndpointMessageTypeDef,
    ModifyDBClusterMessageTypeDef,
    ModifyDBClusterParameterGroupMessageTypeDef,
    ModifyDBClusterResultResponseTypeDef,
    ModifyDBClusterSnapshotAttributeMessageTypeDef,
    ModifyDBClusterSnapshotAttributeResultResponseTypeDef,
    ModifyDBInstanceMessageTypeDef,
    ModifyDBInstanceResultResponseTypeDef,
    ModifyDBParameterGroupMessageTypeDef,
    ModifyDBProxyEndpointRequestTypeDef,
    ModifyDBProxyEndpointResponseResponseTypeDef,
    ModifyDBProxyRequestTypeDef,
    ModifyDBProxyResponseResponseTypeDef,
    ModifyDBProxyTargetGroupRequestTypeDef,
    ModifyDBProxyTargetGroupResponseResponseTypeDef,
    ModifyDBSnapshotAttributeMessageTypeDef,
    ModifyDBSnapshotAttributeResultResponseTypeDef,
    ModifyDBSnapshotMessageTypeDef,
    ModifyDBSnapshotResultResponseTypeDef,
    ModifyDBSubnetGroupMessageTypeDef,
    ModifyDBSubnetGroupResultResponseTypeDef,
    ModifyEventSubscriptionMessageTypeDef,
    ModifyEventSubscriptionResultResponseTypeDef,
    ModifyGlobalClusterMessageTypeDef,
    ModifyGlobalClusterResultResponseTypeDef,
    ModifyOptionGroupMessageTypeDef,
    ModifyOptionGroupResultResponseTypeDef,
    OptionConfigurationTypeDef,
    OptionGroupMembershipTypeDef,
    OptionGroupOptionSettingTypeDef,
    OptionGroupOptionTypeDef,
    OptionGroupOptionsMessageResponseTypeDef,
    OptionGroupTypeDef,
    OptionGroupsResponseTypeDef,
    OptionSettingTypeDef,
    OptionTypeDef,
    OptionVersionTypeDef,
    OrderableDBInstanceOptionTypeDef,
    OrderableDBInstanceOptionsMessageResponseTypeDef,
    OutpostTypeDef,
    PaginatorConfigTypeDef,
    ParameterTypeDef,
    PendingCloudwatchLogsExportsTypeDef,
    PendingMaintenanceActionTypeDef,
    PendingMaintenanceActionsMessageResponseTypeDef,
    PendingModifiedValuesTypeDef,
    ProcessorFeatureTypeDef,
    PromoteReadReplicaDBClusterMessageTypeDef,
    PromoteReadReplicaDBClusterResultResponseTypeDef,
    PromoteReadReplicaMessageTypeDef,
    PromoteReadReplicaResultResponseTypeDef,
    PurchaseReservedDBInstancesOfferingMessageTypeDef,
    PurchaseReservedDBInstancesOfferingResultResponseTypeDef,
    RangeTypeDef,
    RebootDBInstanceMessageTypeDef,
    RebootDBInstanceResultResponseTypeDef,
    RecurringChargeTypeDef,
    RegisterDBProxyTargetsRequestTypeDef,
    RegisterDBProxyTargetsResponseResponseTypeDef,
    RemoveFromGlobalClusterMessageTypeDef,
    RemoveFromGlobalClusterResultResponseTypeDef,
    RemoveRoleFromDBClusterMessageTypeDef,
    RemoveRoleFromDBInstanceMessageTypeDef,
    RemoveSourceIdentifierFromSubscriptionMessageTypeDef,
    RemoveSourceIdentifierFromSubscriptionResultResponseTypeDef,
    RemoveTagsFromResourceMessageTypeDef,
    ReservedDBInstanceMessageResponseTypeDef,
    ReservedDBInstanceTypeDef,
    ReservedDBInstancesOfferingMessageResponseTypeDef,
    ReservedDBInstancesOfferingTypeDef,
    ResetDBClusterParameterGroupMessageTypeDef,
    ResetDBParameterGroupMessageTypeDef,
    ResourcePendingMaintenanceActionsTypeDef,
    ResponseMetadataTypeDef,
    RestoreDBClusterFromS3MessageTypeDef,
    RestoreDBClusterFromS3ResultResponseTypeDef,
    RestoreDBClusterFromSnapshotMessageTypeDef,
    RestoreDBClusterFromSnapshotResultResponseTypeDef,
    RestoreDBClusterToPointInTimeMessageTypeDef,
    RestoreDBClusterToPointInTimeResultResponseTypeDef,
    RestoreDBInstanceFromDBSnapshotMessageTypeDef,
    RestoreDBInstanceFromDBSnapshotResultResponseTypeDef,
    RestoreDBInstanceFromS3MessageTypeDef,
    RestoreDBInstanceFromS3ResultResponseTypeDef,
    RestoreDBInstanceToPointInTimeMessageTypeDef,
    RestoreDBInstanceToPointInTimeResultResponseTypeDef,
    RestoreWindowTypeDef,
    RevokeDBSecurityGroupIngressMessageTypeDef,
    RevokeDBSecurityGroupIngressResultResponseTypeDef,
    ScalingConfigurationInfoTypeDef,
    ScalingConfigurationTypeDef,
    SourceRegionMessageResponseTypeDef,
    SourceRegionTypeDef,
    StartActivityStreamRequestTypeDef,
    StartActivityStreamResponseResponseTypeDef,
    StartDBClusterMessageTypeDef,
    StartDBClusterResultResponseTypeDef,
    StartDBInstanceAutomatedBackupsReplicationMessageTypeDef,
    StartDBInstanceAutomatedBackupsReplicationResultResponseTypeDef,
    StartDBInstanceMessageTypeDef,
    StartDBInstanceResultResponseTypeDef,
    StartExportTaskMessageTypeDef,
    StopActivityStreamRequestTypeDef,
    StopActivityStreamResponseResponseTypeDef,
    StopDBClusterMessageTypeDef,
    StopDBClusterResultResponseTypeDef,
    StopDBInstanceAutomatedBackupsReplicationMessageTypeDef,
    StopDBInstanceAutomatedBackupsReplicationResultResponseTypeDef,
    StopDBInstanceMessageTypeDef,
    StopDBInstanceResultResponseTypeDef,
    SubnetTypeDef,
    TagListMessageResponseTypeDef,
    TagTypeDef,
    TargetHealthTypeDef,
    TimezoneTypeDef,
    UpgradeTargetTypeDef,
    UserAuthConfigInfoTypeDef,
    UserAuthConfigTypeDef,
    ValidDBInstanceModificationsMessageTypeDef,
    ValidStorageOptionsTypeDef,
    VpcSecurityGroupMembershipTypeDef,
    VpnDetailsTypeDef,
    WaiterConfigTypeDef,
)

def get_structure() -> AccountAttributesMessageResponseTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-rds` version is the same as related `boto3` version and follows
[PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-rds docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_rds/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
